class C {
    C(int j) {
	super();
	f = j;
    }
    int f;
    C foo;

    static public void main(String[] args) {
	int i = 9;
	C a, b;
	if (true || false) {
	    a = new C(i);
	    b = new C(i);
	}
	else {
	    a = null;
	    b = new C(i);
	}

	a.foo = a; // a may be null
	b.foo = null; // b cannot be null
    }

}
